<?php
namespace SVIApp;

/**
 * Ajax Handler
 */
class Ajax
{

    public function __construct()
    {
        $this->frontend = new Frontend();
        if (array_key_exists('quick_view', $this->frontend->options) && $this->frontend->options['quick_view']) {
            add_filter('wc_get_template_part', [$this, 'filter_wc_get_template_part__premium_only'], 10, 3);
            add_filter('wc_get_template', [$this, 'filter_wc_get_template__premium_only'], 1, 5);
            add_action('woocommerce_before_single_product', [$this->frontend, 'remove_hooks'], 20);
        }

    }

    public function filter_wc_get_template__premium_only($located, $template_name, $args, $template_path, $default_path)
    {
        // make filter magic happen here...
        $templates = array('single-product/sale-flash.php', 'quick-view/product-images.php');
        if (in_array($template_name, $templates)) {
            return $this->frontend->render_frontend();
        } else {
            return $located;
        }

        return $located;
    }

    public function filter_wc_get_template_part__premium_only($template, $slug, $name)
    {
        $theme = wp_get_theme();

        $template = $this->woo_svi_plugin_path() . "/includes/quickviews/{$theme->template}.php";

        return $template;
    }

    /**
     * Plugin path
     *
     * @since 1.0.0
     * @return html
     */
    public function woo_svi_plugin_path()
    {
        return untrailingslashit(plugin_dir_path(dirname(__FILE__)));
    }

}
